"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var transformer = require('istanbul-lib-source-maps/lib/transformer');
var istanbul_lib_coverage_1 = require("istanbul-lib-coverage");
var source_map_1 = require("source-map");
exports.getCoverage = function (file) {
    var coverage = fs.readFileSync(file);
    return exports.getSourceCodeCoverage(JSON.parse(coverage.toString()));
};
exports.getSourceCodeCoverage = function (coverageData) { return __awaiter(void 0, void 0, void 0, function () {
    var result, randomFileCov, _loop_1, _a, _b, _i, key;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                result = {};
                randomFileCov = randomProperty(coverageData);
                if (!randomFileCov.inputSourceMap) {
                    return [2, coverageData];
                }
                _loop_1 = function (key) {
                    var fileCov, coverageMap, finder, mapped;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                fileCov = coverageData[key];
                                coverageMap = istanbul_lib_coverage_1.createCoverageMap({});
                                coverageMap.addFileCoverage(fileCov);
                                return [4, new source_map_1.SourceMapConsumer(fileCov.inputSourceMap)];
                            case 1:
                                finder = _a.sent();
                                mapped = transformer.create(function () { return finder; }).transform(coverageMap);
                                Object.assign(result, mapped.data);
                                return [2];
                        }
                    });
                };
                _a = [];
                for (_b in coverageData)
                    _a.push(_b);
                _i = 0;
                _c.label = 1;
            case 1:
                if (!(_i < _a.length)) return [3, 4];
                key = _a[_i];
                return [5, _loop_1(key)];
            case 2:
                _c.sent();
                _c.label = 3;
            case 3:
                _i++;
                return [3, 1];
            case 4: return [2, result];
        }
    });
}); };
var randomProperty = function (obj) {
    var keys = Object.keys(obj);
    return obj[keys[keys.length * Math.random() << 0]];
};
//# sourceMappingURL=coverage-utils.js.map