"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var cli = require("./cli");
var configuration_1 = require("./configuration");
var log = require("./logger");
var utils = require("./utils");
var yargs = require("./yargs");
var coverageUtils = require("./coverage-utils");
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var argv, _a, diff2htmlOptions, configuration, coverage, input, output, error_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 6, , 7]);
                    argv = yargs.setup();
                    _a = configuration_1.parseArgv(argv), diff2htmlOptions = _a[0], configuration = _a[1];
                    coverage = null;
                    if (!configuration.coverage) return [3, 2];
                    return [4, coverageUtils.getCoverage(configuration.coverage)];
                case 1:
                    coverage = _b.sent();
                    _b.label = 2;
                case 2: return [4, cli.getInput(configuration.inputSource, argv.extraArguments, configuration.ignore)];
                case 3:
                    input = _b.sent();
                    if (!input) {
                        log.error("The input is empty. Try again.");
                        yargs.help();
                        return [2];
                    }
                    if (!(configuration.diffyType !== undefined)) return [3, 5];
                    return [4, cli.postToDiffy(input, configuration.diffyType)];
                case 4:
                    _b.sent();
                    return [2];
                case 5:
                    output = cli.getOutput(diff2htmlOptions, configuration, input, coverage);
                    if (configuration.outputDestinationFile)
                        utils.writeFile(configuration.outputDestinationFile, output);
                    if (configuration.outputDestinationType === "preview") {
                        cli.preview(output, configuration.formatType);
                    }
                    else if (configuration.outputDestinationType === "stdout") {
                        log.print(output);
                    }
                    return [3, 7];
                case 6:
                    error_1 = _b.sent();
                    log.error(error_1);
                    return [3, 7];
                case 7: return [2];
            }
        });
    });
}
exports.main = main;
//# sourceMappingURL=main.js.map